//************************************************************************************
//**  
//**  File name:     E:\PIC\AVR\PWM_mega128\M32\pwm_32_1.c
//**  Generated by:  Flowcode v4.3.9.65
//**  Date:          Tuesday, May 07, 2013 10:58:33
//**  Licence:       Free version
//**  
//**        ***For users exUSSR ***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_EE
#define MX_EE_SIZE 1024
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 6
#define MX_SPI_SDO 5
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 1
#define MX_I2C_SCL 0
#define MX_PWM
#define MX_PWM_PORT PORTD
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRD
#define MX_PWM_1 5
#define MX_PWM_TRIS2 DDRD
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 8000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_PWM_1_Init(char FCL_BITRES, char FCL_FAST);
void FCM_SetPrescale_1(char FCL_PRESCALE);
void FCM_PWM_1_Init_ICR(short FCL_TOPCOUNT, char FCL_FAST);
void FCM_PWM_1_AOn();
void FCM_PWM_1_BOn();
void FCM_PWM_1_ASet(short FCL_PWMDUTY);
void FCM_PWM_1_BSet(short FCL_PWMDUTY);
void FCM_PWM_1_Off();
void FCM_PWM_1_AOff();
void FCM_PWM_1_BOff();
void FCM_KNOPKI();


//Variable declarations
volatile char FCV_PORT;
volatile char FCV_ADC;
volatile char FCV_INV;
volatile char FCV_FLAG_;


//Defines:

/**** Macro Substitutions ****
0 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

static void FCD_ADC0_SampleADC();
static char FCD_ADC0_ReadAsByte();
static short FCD_ADC0_ReadAsInt();
static float FCD_ADC0_ReadAsVoltage();
static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);



//ADC(0): //Macro implementations


static void FCD_ADC0_SampleADC()
{
	
		#define MX_ADC_CHANNEL		0
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char dda;
		volatile char cnt;

		dda = DDRA;

		//turn selected ADC on
		DDRA &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRA = dda;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return ADCH;

}

static short FCD_ADC0_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}

//Macro implementations

void FCM_PWM_1_Init(char FCL_BITRES, char FCL_FAST)
{
	
	//Comment:
	//


	//Fast  or Correct
	//Decision: PWM_1_Init.Fast?
	if (FCL_FAST)
	{
		//Comment:
		//Fast PWM


		//C Code
		//C Code:
		//set_bit(TCCR1B,WGM12);
		// TCCR1B = 1<<WGM12; 

		//bit_is_set(TCCR1B, WGM12);
		//TCCR1B |= 1<<WGM12; 
		TCCR1B = _BV(WGM12);


	} else {
		//Comment:
		//Phase Correct


		//C Code
		//C Code:
		clear_bit(TCCR1B,WGM12); 



	}


	//Comment:
	// 


	//C Code
	//C Code:
	//TCCR1B = FCL_FAST<<WGM12; 


	//Decision
	//Decision: PWM_1_Init.bitRes= 9?
	if (FCL_BITRES== 9)
	{
		//Comment:
		//9 


		//
		//C Code:
		       // 9bit mode                  
			set_bit(TCCR1A,WGM11);                  
			clear_bit(TCCR1A,WGM10);   



	} else {
		//Decision
		//Decision: PWM_1_Init.bitRes= 10?
		if (FCL_BITRES== 10)
		{
			//Comment:
			//10 


			//
			//C Code:
			       // 10bit mode                  
				set_bit(TCCR1A,WGM11);                  
				set_bit(TCCR1A,WGM10); 



		} else {
			//Comment:
			//8 


			//
			//C Code:
			       // default 8bit mode                  
				clear_bit(TCCR1A,WGM11);                  
				set_bit(TCCR1A,WGM10);     


		}


	}


	//Comment:
	//Comment


	//
	//C Code:
	// clear output compare value A          
	OCR1A=0;          
	        
	// clear output compare value B          
	OCR1B=0;          
	         
	   
	 


	//Comment:
	//    


	//Goto Connection Point
	//Goto Connection Point: [A]: A
	goto FCC_PWM_1_Init_A;


	//C Code
	//C Code:
	// configures timer1 for use with PWM output          
	// on pins OC1A, OC1B, and OC1C            
	// enable Timer1 as 8,9,10bit PWM
	//TCCR1A=0;          
	if(FCL_BITRES == 9)          
		{       // 9bit mode                  
		set_bit(TCCR1A,WGM11);                  
		clear_bit(TCCR1A,WGM10);
	          
		}          
	else 	if( FCL_BITRES == 10 )          
			{       // 10bit mode                  
			set_bit(TCCR1A,WGM11);                  
			set_bit(TCCR1A,WGM10);          
			}          
			else          
			{       // default 8bit mode                  
			clear_bit(TCCR1A,WGM11);                  
			set_bit(TCCR1A,WGM10);
	//TCCR1A=255;
	//TCCR1A = (1<<WGM11) | (1<<WGM10);
	//TCCR1A = (1<<WGM11) | (1<<COM1A0);
			}            
	// set clear-timer-on-compare-match          
	// clear_bit(TCCR1B,WGM12);          
	// clear output compare value A          
	OCR1A=0;          
	        
	// clear output compare value B          
	OCR1B=0;          
	   
	 



	//Connection Point
	//Connection Point: [A]: A
FCC_PWM_1_Init_A:
;


}

void FCM_SetPrescale_1(char FCL_PRESCALE)
{
	
	//C Code
	//C Code:
	//0,1,8,64,256,1024
	//0,1,2,3 ,4  ,5   ,6,7
	TCCR1B=(TCCR1B&0xF8) | FCL_PRESCALE;


}

void FCM_PWM_1_Init_ICR(short FCL_TOPCOUNT, char FCL_FAST)
{
	
	//Decision
	//Decision: PWM_1_Init_ICR.Fast?
	if (FCL_FAST)
	{
		//Comment:
		//Fast PWM


		//C Code
		//C Code:
		// set PWM mode with ICR top-count 
		// Fast PWM        
		clear_bit(TCCR1A,WGM10);          
		set_bit(TCCR1A,WGM11);          
		set_bit(TCCR1B,WGM12);         
		set_bit(TCCR1B,WGM13);


	} else {
		//Comment:
		//Phase 
		//and Frequency 
		//Correct


		//C Code
		//C Code:
		// set PWM mode with ICR top-count        
		clear_bit(TCCR1A,WGM10);          
		clear_bit(TCCR1A,WGM11);          
		clear_bit(TCCR1B,WGM12);         
		set_bit(TCCR1B,WGM13);


	}


	//Goto Connection Point
	//Goto Connection Point: [A]: A
	goto FCC_PWM_1_Init_ICR_A;


	//Comment:
	//PWM, Phase Correct


	//C Code
	//C Code:
	// set PWM mode with ICR top-count 
	// Fast PWM        
	clear_bit(TCCR1A,WGM10);          
	set_bit(TCCR1A,WGM11);          
	clear_bit(TCCR1B,WGM12);         
	set_bit(TCCR1B,WGM13);


	//Connection Point
	//Connection Point: [A]: A
FCC_PWM_1_Init_ICR_A:
;


	//C Code
	//C Code:
	// set top count value          
	ICR1 = FCL_TOPCOUNT;          
	                   
	// clear output compare value A          
	OCR1A=0;          
	       
	// clear output compare value B          
	OCR1B=0;          
	      



}

void FCM_PWM_1_AOn()
{
	
	//C Code
	//C Code:
	// turn on channel A (OC1A) PWM output          
	// set OC1A as non-inverted PWM          
	set_bit(TCCR1A,COM1A1);     
	//clear_bit(TCCR1A,COM1A1);       
	clear_bit(TCCR1A,COM1A0); 
	//set_bit(TCCR1A,COM1A0); 
	set_bit(DDRD, 5);


}

void FCM_PWM_1_BOn()
{
	
	//C Code
	//C Code:
	// turn on channel B (OC1B) PWM output         
	// set OC1B as non-inverted PWM          
	set_bit(TCCR1A,COM1B1);          
	clear_bit(TCCR1A,COM1B0);  
	set_bit(DDRD, 4);


}

void FCM_PWM_1_ASet(short FCL_PWMDUTY)
{
	
	//C Code
	//C Code:
	// set PWM (output compare) duty for channel A          
	// this PWM output is generated on OC1A pin          
	// NOTE:        pwmDuty should be in the range 0-255 for 8bit PWM          
	//              pwmDuty should be in the range 0-511 for 9bit PWM          
	//              pwmDuty should be in the range 0-1023 for 10bit PWM          
	OCR1A = FCL_PWMDUTY;     // set  OCR1A          



}

void FCM_PWM_1_BSet(short FCL_PWMDUTY)
{
	
	//C Code
	//C Code:
	// set PWM (output compare) duty for channel B          
	// this PWM output is generated on OC1B pin          
	// NOTE: pwmDuty should be in the range 0-255 for 8bit PWM          
	//       pwmDuty should be in the range 0-511 for 9bit PWM          
	//       pwmDuty should be in the range 0-1023 for 10bit PWM          
	OCR1B = FCL_PWMDUTY;      // set  OCR1B          



}

void FCM_PWM_1_Off()
{
	
	//C Code
	//C Code:
	// turn off PWM on Timer1          
	clear_bit(TCCR1A,WGM11);          
	clear_bit(TCCR1A,WGM10);  



	//Call Macro
	//Call Macro: PWM_1_AOff
	FCM_PWM_1_AOff();


	//Call Macro
	//Call Macro: PWM_1_BOff
	FCM_PWM_1_BOff();


}

void FCM_PWM_1_AOff()
{
	
	//C Code
	//C Code:
	 // turn off channel A (OC1A) PWM output          
	// set OC1A (OutputCompare action) to none          
	clear_bit(TCCR1A,COM1A1);          
	clear_bit(TCCR1A,COM1A0);  



}

void FCM_PWM_1_BOff()
{
	
	//C Code
	//C Code:
	// turn off channel B (OC1B) PWM output          
	// set OC1B (OutputCompare action) to none          
	clear_bit(TCCR1A,COM1B1);          
	clear_bit(TCCR1A,COM1B0); 




}

void FCM_KNOPKI()
{
	
	//Delay
	//Delay: 20 ms
	delay_ms(20);


	//Comment:
	//   -   "".
	//      .
	//       .


	//
	//Input: PORT C -> PORT
	DDRC = DDRC & 0xf0;
	FCV_PORT = PINC & 0x0f;


	//Calculation
	//Calculation:
	//  PORT = (~PORT)&7
	FCV_PORT = (~FCV_PORT)&7;
	

	//Decision
	//Decision: PORT>0 AND flag_=1?
	if (FCV_PORT>0 & FCV_FLAG_==1)
	{
		//Switch
		//Switch: PORT?
		switch (FCV_PORT)
		{
			case 1:
			{
				//Comment:
				// 


				//Calculation
				//Calculation:
				//  INV = ~INV
				FCV_INV = ~FCV_INV;
				

				//Fast  or Correct
				//Decision: INV?
				if (FCV_INV)
				{
					//Comment:
					//Fast PWM


					//C Code
					//C Code:
					//set_bit(TCCR1B,WGM12);
					// TCCR1B = 1<<WGM12; 

					//bit_is_set(TCCR1B, WGM12);
					TCCR1B |= 1<<WGM12; 
					//TCCR1B = _BV(WGM12);


				} else {
					//Comment:
					//Phase Correct


					//C Code
					//C Code:
					clear_bit(TCCR1B,WGM12); 



				}


				break;
			}

			case 2:
			{
				//Comment:
				// 


				//Calculation
				//Calculation:
				//  INV = ~INV
				FCV_INV = ~FCV_INV;
				

				//Fast  or Correct
				//Decision: INV?
				if (FCV_INV)
				{
					//Comment:
					//Fast PWM


					//C Code
					//C Code:
					set_bit(TCCR1A,WGM11);          
					set_bit(TCCR1B,WGM12); 


				} else {
					//Comment:
					//Phase Correct


					//C Code
					//C Code:
					clear_bit(TCCR1A,WGM11);          
					clear_bit(TCCR1B,WGM12);    


				}


				break;
			}

			case 4:
			{
				//Comment:
				// 


				//Call Macro
				//Call Macro: 
				//No code generated because there is no macro name



				break;
			}

			case 8:
			{
				//Comment:
				// 


				//Call Macro
				//Call Macro: 
				//No code generated because there is no macro name



				break;
			}

		}


		//
		//Calculation:
		//  flag_ = 0
		FCV_FLAG_ = 0;
		

	} else {
		//Decision
		//Decision: PORT=0 AND flag_=0?
		if (FCV_PORT==0 & FCV_FLAG_==0)
		{
			//Calculation
			//Calculation:
			//  flag_ = 1
			FCV_FLAG_ = 1;
			

		}


	}


}

int main()
{
	
	//Initialisation
	MCUCSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//Comment:
	// 1


	//Comment:
	//  
	//  8,9,10
	//(PWM, Phase Correct) = 0
	//(Fast PWM) = 1


	//Call Macro
	//Call Macro: PWM_1_Init(10, 1)
	FCM_PWM_1_Init(10, 1);


	//Goto Connection Point
	//Goto Connection Point: [A]: A
	goto FCC_Main_A;


	//Comment:
	// 2


	//Call Macro
	//Call Macro: PWM_1_Init_ICR(1040, 0)
	FCM_PWM_1_Init_ICR(1040, 0);


	//Connection Point
	//Connection Point: [A]: A
FCC_Main_A:
;


	//Comment:
	// 
	////0,1,8,64,256,1024
	////0,1,2,3 ,4  ,5   ,6,7


	//Call Macro
	//Call Macro: SetPrescale_1(3)
	FCM_SetPrescale_1(3);


	//Comment:
	// 


	//Call Macro
	//Call Macro: PWM_1_ASet(512)
	FCM_PWM_1_ASet(512);


	//Comment:
	// 
	// nX
	// 


	//Call Macro
	//Call Macro: PWM_1_AOn
	FCM_PWM_1_AOn();


	//Call Macro
	//Call Macro: PWM_1_BSet(512)
	FCM_PWM_1_BSet(512);


	//Call Macro
	//Call Macro: PWM_1_BOn
	FCM_PWM_1_BOn();


	//Loop
	//Loop: While 1
	while (1)
	{
		//Call Component Macro
		//Call Component Macro: ADC=ADC(0)::ReadAsByte
		FCV_ADC = FCD_ADC0_ReadAsByte();


		//Comment:
		// 


		//C Code
		//C Code:
		//ICR1 = FCV_ADC;  


		//Comment:
		// 


		//Call Macro
		//Call Macro: PWM_1_ASet(ADC)
		FCM_PWM_1_ASet(FCV_ADC);


		//Call Macro
		//Call Macro: KNOPKI
		FCM_KNOPKI();


	}


	mainendloop: goto mainendloop;
}



